//+------------------------------------------------------------------+
//|                                                   MA Chanels.mq4 |
//|                                                           njel |
//|                                                     iamnotlinked |
//|                                                      Quantum.mq4 |
//+------------------------------------------------------------------+
//|                                                   Quantum.mq4    |
//|                                         Copyright  2010, zznbrm |
//|
//+------------------------------------------------------------------+
//|  2012Jan27 mod for mer071898
//+------------------------------------------------------------------+
//|
//| 10.12.2015 Genry : MA_Channels+Quantum = QuMA_ChannelsFIBO.mq4
//| 10.01.2016 Genry : Add the algorithm for finding extrema.
//|            The idea and code Deviat: Development Slim33 10/18/2014
//| 11.01.2016 Staxis: Increasing the speed indicator.
//| 11.01.2016 Genry : MIN version to work with the advisor. 
//|                    It works faster than the standard version.
//+------------------------------------------------------------------+

#property copyright "zznbrm+njel+Genry"
#property link      "notlinked"

#property indicator_chart_window
#property indicator_buffers 2

#property indicator_color1 clrAquamarine
#property indicator_color2 clrMagenta
#property indicator_width1 5
#property indicator_width2 5

//---- input parameters Quantum
extern int     eintDepth3 = 78;

// 1= 23.6 2=38.4 3=50 4=61.8 5=78.6 6=Gann 82.87 7= 88.2 8=100
extern int     FibSelect  = 2; 

//--------------------- MA
extern int     BarsCount = 500;
extern int     MAPeriod  = 100;
extern int     MAMethod  = MODE_SMA;
extern int     MAPrice   = PRICE_CLOSE;
extern int     fontsize  = 10;

double FibMult = 0.0;

double Inc0 = 0.0000;
double Inc1 = 0.0000;
double Inc2 = 0.0000;
double Inc3 = 0.0000;
double Inc4 = 0.0000;
double Inc5 = 0.0000;
double Inc6 = 0.0000;
double Inc7 = 0.0000;

//---- buffers
double gadblUp3[];  // Quantum
double gadblDn3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   SetIndexBuffer( 0, gadblUp3 );
   SetIndexEmptyValue( 0, 0.0 );
   SetIndexStyle( 0, DRAW_ARROW );
   SetIndexArrow( 0, 250 ); 
   SetIndexLabel( 0, NULL );
   
   SetIndexBuffer( 1, gadblDn3 );
   SetIndexEmptyValue( 1, 0.0 );
   SetIndexStyle( 1, DRAW_ARROW );
   SetIndexArrow( 1, 250 ); 
   SetIndexLabel( 1, NULL ); 
  

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double dev = 0;
   
   int intLow3, intHigh3, limit;

//   if (iBars(NULL,0) < BarsCount)
//      BarsCount = iBars(NULL,0) - MAPeriod-1 ;

   int counted_bars = IndicatorCounted();
   //---- check for possible errors
   if(counted_bars < 0)       
       return(-1);
   if(counted_bars <= MAPeriod)
       limit = Bars - MAPeriod ;
   else
       limit = Bars - counted_bars;   
   for (int i =limit; i>=0; i--)
   {  
       
      dev = Deviat(i);
      if(dev == 0) continue;
      
      Inc2 = dev*0.618;
      Inc1 = dev*0.5;
      Inc0 = dev*0.236;
      Inc4 = dev*0.786;
      Inc5 = dev*0.828; // Gann 82.87
      Inc6 = dev*0.882;
      Inc7 = Inc3;       // 100%            
      Inc3 = dev*0.382;

      //-------------------------------------
      double m = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i);        
      
      gadblUp3[i] = 0.0;
      gadblDn3[i] = 0.0;
      
      switch ( FibSelect )
      {                                       
        case 1: FibMult =  m -Inc0; break;   // 23.6              
        case 2: FibMult =  m -Inc3; break;   // 38.2          
        case 3: FibMult =  m -Inc1; break;   // 50           
        case 4: FibMult =  m -Inc2; break;   // 61.8 
        case 5: FibMult =  m -Inc4; break;   // 78.6          
        case 6: FibMult =  m -Inc5; break;   // Gann 82.87 
        case 7: FibMult =  m -Inc6; break;   // 88.2               
        case 8: FibMult =  m -Inc7; break;   // 100.0
 
        default: FibMult = m -Inc3;
      }     
      
      intLow3 = iLowest( Symbol(), Period(), MODE_LOW, eintDepth3, i );
      
      if ( intLow3 == i ) { 
         if (Low[i] <= FibMult) gadblUp3[i] = Low[i];
      } 
    
      switch ( FibSelect )
      {                                       
        case 1: FibMult =  m +Inc0; break;   // 23.6              
        case 2: FibMult =  m +Inc3; break;   // 38.2          
        case 3: FibMult =  m +Inc1; break;   // 50           
        case 4: FibMult =  m +Inc2; break;   // 61.8
        case 5: FibMult =  m +Inc4; break;   // 78.6
        case 6: FibMult =  m +Inc5; break;   // Gann 82.87 
        case 7: FibMult =  m +Inc6; break;   // 88.2 
        case 8: FibMult =  m +Inc7; break;   // 100.0          

        default: FibMult = m +Inc3;
      }     
      
      intHigh3 = iHighest( Symbol(), Period(), MODE_HIGH, eintDepth3, i );
      
      if ( intHigh3 == i ) {
        if (High[i] >= FibMult)  gadblDn3[i] = High[i];
      }
   }
  return(0);
}

//+------------------------------------------------------------------+
//|Slim33 18.10.2014
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
double Deviat(int bar)
{
   int i;
   double val = 0, loDev = 0, hiDev = 0;
   
   if( bar + BarsCount >= Bars - 1) return(0);
     
   for (i = bar + BarsCount; i >= bar; i--)
   {
   
      double m = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i);
     
      if(MathAbs(m - High[ i]) > hiDev)
         hiDev = MathAbs(m - High[ i]);
      
       if(MathAbs(m - Low[ i]) > loDev)
         loDev = MathAbs(m - Low[ i]);
   }
   val = MathMax(hiDev, loDev);
   return (val);
}